#ifndef ALARMSETTINGSDIALOG_H
#define ALARMSETTINGSDIALOG_H

#include <QDialog>
#include <QTime>
#include <QString>
#include <QSettings>

#include "alarmtime.h"

namespace Ui {
class AlarmSettingsDialog;
}

class AlarmSettingsDialog : public QDialog
{
    Q_OBJECT

    AlarmTime* almNight_;
    AlarmTime* almAlarm_;
    QSettings* settings_;


public:
    explicit AlarmSettingsDialog(AlarmTime* almNight, AlarmTime* almAlarm, QSettings* settings, QWidget* parent = nullptr);
    ~AlarmSettingsDialog();

signals:
    void signalAlarmSoundFile(QString fileName);
    void signalSunrise(bool enabled);

public slots:
    void accept();

private slots:
    void showFileChooser();


private:
    Ui::AlarmSettingsDialog *ui;
};

#endif // ALARMSETTINGSDIALOG_H
