#include "relaydialog.h"
#include "ui_relaydialog.h"

RelayDialog::RelayDialog(Microcontroller *micro, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::RelayDialog),
    _micro(micro)
{
    ui->setupUi(this);

    _relayCheckBoxes.push_back(ui->checkBox_R0);
    _relayCheckBoxes.push_back(ui->checkBox_R1);

    for(unsigned int i = 0; i < _relayCheckBoxes.size(); i++) connect(_relayCheckBoxes[i], SIGNAL(stateChanged(int)), this, SLOT(relayCheckBoxToggeled(int)));

    _micro->relayOn(STARTING_RELAY);

}

RelayDialog::~RelayDialog()
{
    delete ui;
}


void RelayDialog::relayCheckBoxToggeled(int state)
{
    for(unsigned int i = 0; i < _relayCheckBoxes.size(); i++)
    {

        if(_relayCheckBoxes[i] == sender())
        {
            std::cerr<<state<<"  "<<i<<std::endl;
            if(state == 2 && i == 0)
            {
                std::cerr<<"primeing lambda\n";
                QTimer::singleShot(3600000, _micro, [this](){ _micro->relayOff(STARTING_RELAY); _relayCheckBoxes[0]->setChecked(false);});
            }
            _micro->relayToggle(state, i+STARTING_RELAY);
        }
    }
}

void RelayDialog::relayStateChanged(std::vector<bool> relayStates)
{
    if(relayStates.size() > STARTING_RELAY) for(unsigned int i = 0; i < relayStates.size()-STARTING_RELAY; i++)
    {
        _relayCheckBoxes[i]->blockSignals(true);
        _relayCheckBoxes[i]->setChecked(relayStates[i+STARTING_RELAY]);
        _relayCheckBoxes[i]->blockSignals(false);
    }
}
